/**************************************************************************/
/*   Earth Rover 01@(AKI H8/3664F) p \tg*/
/*   2009/12/26 쐬*/
/**************************************************************************/

#include <3664F.H>
#include "w7a.h"

void main(void)
{
unsigned char	command, sonic_count, PSD_count, LED_count;
unsigned int	timer;

struct SIO		sio;

	/*|[gȂǂ̏*/
	init_main();

	/*sԃtO@~ԂɃZbg*/
	sio.flg_running = 0;

	/*ϐ*/
	sonic_count = 0;
	PSD_count = 0;
	sio.touch_abort = 1;
	sio.switch_servo = 1;

	/*qbT[{o̓f[^*/
	/*ER-01p*/
	sio.servo_data[0] = 1730;
	sio.servo_data[1] = STOP_VAL;
	sio.servo_data[2] = 1720;
	sio.servo_data[3] = 1720;

	sio.servo_data[4] = 1720;
	sio.servo_data[5] = 1720;
	sio.servo_data[6] = 1720;
	sio.servo_data[7] = 1720;

/********************************************************/
	LED_count = 0;
	while(1)
	{
		TW.TCNT = 0;
		/*ʐM֘ÃZNV*/
		do{
			command = sio_comm(&sio);
			timer = TW.TCNT;
		}while(timer < 40000 && command == 0);

		/*qbT[{Mo*/
		if(sio.switch_servo == 1) generate_signal(sio.servo_data);

		if(sio.flg_running == 1)
		{
			/*^b`A{[g*/
			sio.touch_sw = IO.PDR1.BIT.B5 * 2 + IO.PDR1.BIT.B4 + '0';
			if(sio.touch_sw != '3' && sio.touch_abort == 1)
			{
				sio.servo_data[1] = STOP_VAL;
				sio.flg_running = 8;
			}

			/*sI`FbN*/
			/*ɑs*/
			if(sio.dist_move <= TV.TCNTV)
			{
				sio.servo_data[1] = STOP_VAL;
				sio.flg_running = 0;
			}
		}

		/*Monitor LED uN*/
		LED_count++;
		if(LED_count > 40) IO.PDR1.BIT.B2 = 0;
		if(LED_count > 50)
		{
			IO.PDR1.BIT.B2 = 1;
			LED_count = 0;
		}
	}
}
/*************************************************************/
/**      T[{M                                     **/
/*************************************************************/
void generate_signal(unsigned int servo_data[8])
{
unsigned char	i, bitptn0;
unsigned int	servo_work[2];

	/*3000JEgłPDT*/

	bitptn0 = 1;
	for(i = 0; i < 4; i++)
	{
		TW.TCNT = 0;
		IO.PDR8.BYTE = bitptn0;
		IO.PDR5.BYTE = bitptn0;

		servo_work[0] = servo_data[i];
		servo_work[1] = servo_data[i + 4];
		wait_val(servo_work);

		IO.PDR8.BYTE = IO.PDR8.BYTE & 0xf0;
		IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf0;

		bitptn0 = bitptn0 * 2;
	}
	return;
}

/*************************************************************/
/**  w肳ꂽԑ҂iRCT[{PWMpj                **/
/*************************************************************/
void wait_val(unsigned int servo_data[2])
{
unsigned char	i;
unsigned int	data[2];

	for(i = 0; i < 2; i++)
	{
		data[i] = 4720 - servo_data[i];
	}

	do{
		if(TW.TCNT >= data[0]) IO.PDR8.BYTE = IO.PDR8.BYTE & 0xf0;
		if(TW.TCNT >= data[1]) IO.PDR5.BYTE = IO.PDR5.BYTE & 0xf0;
	}while (TW.TCNT < data[0] || TW.TCNT < data[1]);

	return;
}

/*************************************************************/
/**  e|[g                                       **/
/*************************************************************/
void init_main(void)
{
	/*kdc|[gioPQĵݏo*/
	IO.PCR1 = 0x04;

	/*gZTڑ|[g@vAbv*/
	IO.PUCR1.BIT.B1 = 0;

	/*^b`ZTڑ|[g@vAbv*/
	IO.PUCR1.BIT.B4 = 1;
	IO.PUCR1.BIT.B5 = 1;

	/*qbT[{ڑ|[g*/
	IO.PCR5 = 0x0f;
	IO.PCR8 = 0x0f;

	/*NbNWT*/
	TW.TCRW.BIT.CKS = 3;
	/*TW Startt[jO[h*/
	TW.TMRW.BIT.CTS = 1;

	/*VAC^[tFCX*/
	SCI3.SCR3.BYTE	= 0x00;
	SCI3.SMR.BYTE	= 0x00;

	/*SCI3.BRR		= 12;*/		/*38400 bps*/
	SCI3.BRR		= 25;		/*19200 bps*/
	/*SCI3.BRR		= 51;*/		/*9600 bps*/

	/*A/DRo[^@WX^ݒ*/
	/*Pꃂ[h*/
	AD.CSR.BIT.SCAN = 0;
	/*vXe[g134*/
	AD.CSR.BIT.CKS = 0;

	/*Wait*/
	TW.TCNT = 0;
	while(TW.TCNT < 1000);

	SCI3.SCR3.BIT.TE = 1;
	SCI3.SCR3.BIT.RE = 1;

	IO.PMR1.BIT.TXD = 1;

	/*ւ̃GR[_̃pXJEg*/
	/*TV Start ONbN@t[jO[h*/
	TV.TCRV0.BYTE = 6;

}

/*************************************************************/
/*gṽf[^擾@HLbgp*/
/*************************************************************/
unsigned int read_sonic(void)
{
	TW.TCNT = 0;
	while(IO.PDR1.BIT.B1 == 0)
	{
		if(TW.TCNT > 60000)
		{
			/*C^[ôQUDTɃ}[WĂRO
			60000JEg̎ԂŃpX߂Ȃ΃WI[o[*/
			return(40757);
		}
	};

	while(IO.PDR1.BIT.B1 == 1);

	/*Jn*/
	TW.TCNT = 0;
	while(IO.PDR1.BIT.B1 == 0)
	{
		/*ő僌W炩߃Zbg*/
		/*pXԂȂꍇ́A̒l߂lƂȂB*/
		/*WI[o[*/
		if(TW.TCNT > 40757) break;
	};
	return(TW.TCNT);
}

/*************************************************************/
/*orcṽf[^擾*/
/*************************************************************/
void read_PSD(unsigned char *PSD_L, unsigned char *PSD_R)
{
		/*Pꃂ[hł`mO`Pǂݎ*/
		AD.CSR.BIT.CH = 0;
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		*PSD_R = (unsigned char)(AD.DRA / 256);/*EHorc*/

		AD.CSR.BIT.CH = 1;
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		*PSD_L = (unsigned char)(AD.DRB / 256);/*Horc*/
}